/* 
    %W%
    %D% %T%
   
        author: Mike Henderson mhender@watson.ibm.com
        date:   April 1, 2002                     */

#ifndef __MFCONTINUATIONMETHOD__
#define __MFCONTINUATIONMETHOD__
#include <MFImplicitMF.h>
#include <MFNRegion.h>
#include <MFNVector.h>
#include <MFNKMatrix.h>
#ifdef __cplusplus
extern "C"
 {
#endif

struct MFContinuationMethodST{
                              char *type;
                              void *parmBlock;
                              MFAtlas (*ComputeAtlas)(struct MFContinuationMethodST*,MFImplicitMF,MFNRegion,int,MFNVector*);
                              void (*ExtendAtlas)(struct MFContinuationMethodST*,MFAtlas,MFImplicitMF,MFNRegion,int,MFNVector*,MFNKMatrix*);
                              void (*CloseAtlas)(struct MFContinuationMethodST*,MFAtlas);
                              void (*FlushAtlas)(struct MFContinuationMethodST*,MFAtlas);
                             };

typedef struct MFContinuationMethodST *MFContinuationMethod;

void MFContinuationMethodExtendAtlasMultiple(MFContinuationMethod,MFAtlas,MFImplicitMF,MFNRegion,int,MFNVector*,MFNKMatrix*);
void MFContinuationMethodCloseAtlas(MFContinuationMethod,MFAtlas);
void MFContinuationMethodFlushAtlas(MFContinuationMethod,MFAtlas);

void MFHendersonExtendAtlasMultiple(MFContinuationMethod,MFAtlas,MFImplicitMF,MFNRegion,int,MFNVector*,MFNKMatrix*);
void MFHendersonCloseAtlas(MFContinuationMethod,MFAtlas);
void MFHendersonFlushAtlas(MFContinuationMethod,MFAtlas);

MFContinuationMethod MFCreateHendersonsMethod();
void MFFreeHendersonsMethod(MFContinuationMethod);
void MFHendersonsMethodSetVerbose(MFContinuationMethod,int);
int MFHendersonsMethodGetVerbose(MFContinuationMethod);
void MFHendersonsMethodSetMaxCharts(MFContinuationMethod,int);
int MFHendersonsMethodGetMaxCharts(MFContinuationMethod);
void MFHendersonsMethodSetMinR(MFContinuationMethod,int);
double MFHendersonsMethodGetMinR(MFContinuationMethod);
void MFHendersonsMethodSetMaxR(MFContinuationMethod,int);
double MFHendersonsMethodGetMaxR(MFContinuationMethod);
void MFHendersonsMethodSetEpsilon(MFContinuationMethod,double);
double MFHendersonsMethodGetEpsilon(MFContinuationMethod);
void MFHendersonsMethodSetDotMin(MFContinuationMethod,double);
double MFHendersonsMethodGetDotMin(MFContinuationMethod);
void MFHendersonsMethodSetPage(MFContinuationMethod,int);
int MFHendersonsMethodGetPage(MFContinuationMethod);
void MFHendersonsMethodSetPageEvery(MFContinuationMethod,int);
int MFHendersonsMethodGetPageEvery(MFContinuationMethod);
void MFHendersonsMethodSetDumpToPlotFile(MFContinuationMethod,int);
int MFHendersonsMethodGetDumpToPlotFile(MFContinuationMethod);
void MFHendersonsMethodSetDumpToCenterFile(MFContinuationMethod,int);
int MFHendersonsMethodGetDumpToCenterFile(MFContinuationMethod);
void MFHendersonsMethodSetCheckPoint(MFContinuationMethod,int);
int MFHendersonsMethodGetCheckPoint(MFContinuationMethod);
void MFHendersonsMethodSetCheckPointEvery(MFContinuationMethod,int);
int MFHendersonsMethodGetCheckPointEvery(MFContinuationMethod);
void MFHendersonsMethodSetBranchSwitch(MFContinuationMethod,int);
int MFHendersonsMethodGetBranchSwitch(MFContinuationMethod);
void MFHendersonsMethodSetFilename(MFContinuationMethod,char*);
char *MFHendersonsMethodGetFilename(MFContinuationMethod);
void MFHendersonsMethodAddClipF(MFContinuationMethod,double (*)(MFNVector));
void MFHendersonsMethodClearClipF(MFContinuationMethod);

int MFHendersonsMethodGetDumpToRestartFile(MFContinuationMethod);
void MFHendersonsMethodSetDumpToRestartFile(MFContinuationMethod,int);
int MFHendersonsMethodGetDumpToRestartFileEvery(MFContinuationMethod);
void MFHendersonsMethodSetDumpToRestartFileEvery(MFContinuationMethod,int);
#ifdef __cplusplus
 }
#endif
#endif
