/* 
    %W%
    %D% %T%
   
    PROGRAM NAME:  Manifold
   
    (c) COPYRIGHT INTERNATIONAL BUSINESS MACHINES
    CORPORATION 12/1/2001.  ALL RIGHTS RESERVED.
   
    Please refer to the LICENSE file in the top directory

*/
/*      author: Mike Henderson mhender@watson.ibm.com */
/*      date:   November 11, 1997                     */
/*              February 2, 1999   Ported to C        */

#ifndef __MFNKMATRIX_H__
#define __MFNKMATRIX_H__
#include <MFBase.h>

#include <MFNVector.h>
#include <MFKVector.h>
#include <MFNSpace.h>
#ifdef __cplusplus
extern "C"
 {
#endif
struct MFNKMatrixSt;
typedef struct MFNKMatrixSt *MFNKMatrix;

MFNKMatrix MFCreateNKMatrix(int,MFNVector*);
MFNKMatrix MFCreateNKMatrixWithData(int,int,double*);
void MFRefNKMatrix(MFNKMatrix);
void MFFreeNKMatrix(MFNKMatrix);

int MFNKMatrixK(MFNKMatrix);
int MFNKMatrixN(MFNKMatrix);
MFNVector MFMColumn(MFNKMatrix,int);
void MFMRow(MFNKMatrix,int,MFKVector);
void MFNKMSetC(MFNKMatrix,int,int,double);

void MFMVMul(MFNSpace,MFNKMatrix,MFKVector,MFNVector);
void MFMVMulT(MFNSpace,MFNKMatrix,MFNVector,MFKVector);

void MFWriteNKMatrix(FILE*,MFNKMatrix);
MFNKMatrix MFReadNKMatrix(FILE*);

void MFGramSchmidt(MFNSpace,MFNKMatrix);
void MFGramSchmidtNoMat(int,int,double*);

void MFNKMProjectTangentForBranchSwitch(MFNSpace,MFNKMatrix,MFNVector,MFNKMatrix);
MFNKMatrix MFCloneNKMatrix(MFNKMatrix);
void MFMSetColumn(MFNKMatrix,int,MFNVector);

void MFGramSchmidtPlusOne(MFNSpace,MFNVector,MFNKMatrix,MFNKMatrix);
void MFGramSchmidtReplace(MFNSpace,MFNKMatrix,MFNVector,MFNVector);

void MFMMMul(MFNSpace,MFNKMatrix,MFNKMatrix,double*);
#ifdef __cplusplus
 }
#endif
#endif
