/* 
    @(#)MFNRegion.h	1.11
    02/09/27 11:30:13
   
    PROGRAM NAME:  Manifold
   
    (c) COPYRIGHT INTERNATIONAL BUSINESS MACHINES
    CORPORATION 12/1/2001.  ALL RIGHTS RESERVED.
   
    Please refer to the LICENSE file in the top directory

*/
/*      author: Mike Henderson mhender@watson.ibm.com */
/*      date:   November 11, 1997                     */
/*              February 2, 1999   Ported to C        */

#ifndef __MFNREGION_H__
#define __MFNREGION_H__
#include <MFBase.h>

#include <stdio.h>
#include <MFNVector.h>
#include <MFNSpace.h>
#ifdef __cplusplus
extern "C"
 {
#endif

struct MFNRegionSt;
typedef struct MFNRegionSt *MFNRegion;

int MFNRegionInterior(MFNRegion,MFNVector);
MFNRegion MFNRegionCreateCube(double,double,double,double,double,double);
MFNRegion MFNRegionCreateRectangle(double,double,double,double);
MFNRegion MFNRegionCreateHyperCube(int,double);
MFNRegion MFNRegionCreateHyperCubeByCorners(int,MFNVector,MFNVector);
MFNRegion MFNRegionCreatePendula(int,double,double,int,double,double,double,double,double);
MFNRegion MFNRegionCreatePendulaFour(int,int,double,double,double,double,double,double,double,double,double);
MFNRegion MFNRegionCreateDodecahedronMinusIcosahedron(void);
MFNRegion MFNRegionCreatePolygonal3dRegion(int,double*);
MFNRegion MFNRegionCreateEdge3dRegion(double*,double*);
void MFFreeNRegion(MFNRegion);

int MFCreateTriangulatedPolygon(int,double*,int,int*,int**);

MFNRegion MFNRegionCreatePolyhedral3dRegion(int,double*,int,int*,int**);
MFNRegion MFNRegionCreateTPBVP(int,int,int,double*,double*,double,double);
MFNRegion MFNRegionCreateCSGBalls(int,int,double*,double*,int*);

MFNRegion MFNRegionCreateBaseClass(char*);
void MFNRegionSetTest(MFNRegion,int (*)(MFNVector,void*));
void MFNRegionSetData(MFNRegion,void*);
void *MFNRegionGetData(MFNRegion);
void MFNRegionSetFreeData(MFNRegion,void (*)(void*));
void MFNRegionSetWriteData(MFNRegion,void (*)(FILE*,void*));
#ifdef __cplusplus
 }
#endif
#endif
