/* 
    @(#)MFNVector.h	1.14
    03/07/07 22:24:11
   
    PROGRAM NAME:  Manifold
   
    (c) COPYRIGHT INTERNATIONAL BUSINESS MACHINES
    CORPORATION 12/1/2001.  ALL RIGHTS RESERVED.
   
    Please refer to the LICENSE file in the top directory

*/
/*      author: Mike Henderson mhender@watson.ibm.com */
/*      date:   November 11, 1997                     */
/*              February 2, 1999   Ported to C        */

#ifndef __MFNVECTOR_H__
#define __MFNVECTOR_H__
#include <MFBase.h>

#include <stdio.h>
#ifdef __cplusplus
extern "C"
 {
#endif
struct MFNVectorSt;
typedef struct MFNVectorSt *MFNVector;

MFNVector MFCreateNVectorBaseClass(char*);
void MFNVectorSetPrint(MFNVector,void (*)(FILE*,void*));
void MFNVectorSetData(MFNVector,void*);
void *MFNVectorGetData(MFNVector);
void MFNVectorSetFreeData(MFNVector,void (*)(void*));
void MFNVectorSetWriteData(MFNVector,void (*)(FILE*,void*));
void MFNVectorSetClone(MFNVector,MFNVector (*)(void*));
void MFNVectorSetGetNC(MFNVector,int (*)(void*));
void MFNVectorSetGetC(MFNVector,double (*)(int,void*));
void MFNVectorSetSetC(MFNVector,void (*)(int,double,void*));
void MFNVectorSetAdd(MFNVector,void (*)(void*,void*,void*));
void MFNVectorSetDiff(MFNVector,void (*)(void*,void*,void*));

MFNVector MFCloneNVector(MFNVector);
MFNVector MFCreateNVector(int);
MFNVector MFCreateNVectorWithData(int,double*);
MFNVector MFCreateWrappedNVector(int,double*);

void MFRefNVector(MFNVector);
void MFFreeNVector(MFNVector);
int MFNV_NC(MFNVector);
double MFNV_C(MFNVector,int);
void MFNVSetC(MFNVector,int,double);
void MFNVAdd(MFNVector,MFNVector,MFNVector);
void MFNVDiff(MFNVector,MFNVector,MFNVector);

int MFNVGetIndex(MFNVector);
void MFNVSetIndex(MFNVector,int);

int MFNVGetIndex2(MFNVector);
void MFNVSetIndex2(MFNVector,int);

void MFWriteNVector(FILE*,MFNVector);
MFNVector MFReadNVector(FILE*);

char *MFNVGetId(MFNVector);
#ifdef __cplusplus
 }
#endif
#endif
