/*
 * (C) COPYRIGHT International Business Machines Corp. 1997
 * All Rights Reserved
 * Licensed Materials - Property of IBM
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

#ifndef _DXI_ARCH_H
#define _DXI_ARCH_H 1
#define DXD_VERSION_STRING "03.01.0004"
#define DXD_VERSION         3
#define DXD_RELEASE         1
#define DXD_MODIFICATION    4
#ifdef sgi
typedef signed char     byte;
typedef unsigned char	ubyte;
#include <sys/types.h>
#define DXD_BIGENDIAN 1
#define DXD_ARCHNAME  "sgi"
#define DXD_LICENSED_VERSION 1
#define DXD_IS_MP 1
#define DXD_EXEC_WAIT_PROCESS 1
#define DXD_HAS_SYSMP 1
#define DXD_PROCESSOR_STATUS 1
#define DXD_CAN_HAVE_HW_RENDERING 1
#define DXD_STANDARD_IEEE 1
#define DXD_POPEN_OK 1
#define DXD_PRINTF_RETURNS_COUNT 1
#define DXD_SOCKET_UNIXDOMAIN_OK 1
#define DXD_HAS_GETDTABLESIZE    1
#define DXD_HAS_RLIMIT 1
#define DXD_HW_DC_RIGHT_HANDED 1
#define DXD_HW_WINDOW_DESTRUCTION_CHECK 1
#define DXD_HW_TEXTURE_MAPPING 1
#define DXD_HW_SPECIAL_GAMMA_COMPENSATION 1
#define DXD_HW_API_DISPLAY_LIST_MEMORY 1
#define DXD_EXEC_STATUS_DISPLAY 1
#define DXD_HAS_CRYPT 1
#define RSH  "/usr/bsd/rsh"
#define DXD_HAS_UNIX_SYS_INCLUDES 1
#define DXD_HAS_UNISTD_H 1
#define DXD_GAMMA_8BIT	1.0
#define DXD_GAMMA_12BIT	1.0
#define DXD_GAMMA_24BIT	2.0
#define DXD_NO_MP_RUNTIME 1
#endif   
#ifdef hp700
typedef signed char     byte;
typedef unsigned char	ubyte;
typedef unsigned long	ulong;
#include <sys/types.h>
#define DXD_ARCHNAME  "hp700"
#define DXD_LICENSED_VERSION 1
#define DXD_BIGENDIAN  1
#define DXD_STANDARD_IEEE 1
#define DXD_CAN_HAVE_HW_RENDERING 1
#define DXD_POPEN_OK 1
#define DXD_SYSERRLIST_DECL 1
#define DXD_PRINTF_RETURNS_COUNT 1
#define DXD_SOCKET_UNIXDOMAIN_OK 1
#define DXD_HAS_GETHOSTBYNAME    1
#define DXD_HW_REPARENT_OFFSET_X -2
#define DXD_HW_REPARENT_OFFSET_Y -3
#define DXD_HW_ALPHA_CNTNS 1
#define DXD_HW_ALPHA_POSNS 0
#define DXD_HW_XSERVER_MOVE_OK 1
#define DXD_SELECTPTR_DEFINED  1
typedef int * SelectPtr;
#define DXD_HAS_CRYPT  1
#define RSH "/usr/bin/remsh"
#define DXD_HAS_UNIX_SYS_INCLUDES 1
#define DXD_HAS_UNISTD_H 1
#define DXD_GAMMA_8BIT  2.0
#define DXD_GAMMA_12BIT	2.0
#define DXD_GAMMA_24BIT 2.0
#define DXD_HAS_VFORK 1
#endif  
#ifdef ibm6000
typedef signed char     byte;
typedef unsigned char	ubyte;
#include <sys/types.h>
#define DXD_ARCHNAME  "ibm6000"
#define DXD_LICENSED_VERSION 1
#define DXD_BIGENDIAN 1
#define DXD_STANDARD_IEEE 1
#define DXD_CAN_HAVE_HW_RENDERING 1
#define DXD_IS_MP 1
#define DXD_EXEC_WAIT_PROCESS 1
#define DXD_HAS_SYSCONFIG 1
#define DXD_POPEN_OK 1
#define DXD_SYSERRLIST_DECL 1
#define DXD_PRINTF_RETURNS_COUNT 1
#define DXD_SOCKET_UNIXDOMAIN_OK 1
#define DXD_NEEDS_SYS_SELECT_H   1
#define DXD_HAS_GETDTABLESIZE    1
#define DXD_HAS_GETHOSTBYNAME    1
#define DXD_HAS_SIGDANGER 1
#define DXD_HAS_RLIMIT 1
#define DXD_HW_DC_RIGHT_HANDED 1
#define DXD_HW_XSERVER_MOVE_OK 1
#define DXD_SPECIAL_ACCESS 1
#define DXD_HAS_CRYPT  1
#define RSH "/usr/bin/rsh"
#define DXD_HAS_UNIX_SYS_INCLUDES 1
#define DXD_HAS_UNISTD_H 1
#define DXD_GAMMA_8BIT  2.0
#define DXD_GAMMA_12BIT	2.0
#define DXD_GAMMA_24BIT 2.0
#endif  
#ifdef sun4
typedef signed char     byte;
typedef unsigned char	ubyte;
typedef unsigned long	ulong;
#include <sys/types.h>
#define DXD_ARCHNAME  "sun4"
#define DXD_LICENSED_VERSION 1
#define DXD_BIGENDIAN 1
#define DXD_STANDARD_IEEE 1
#define DXD_CAN_HAVE_HW_RENDERING 1
#define DXD_POPEN_OK 1
#define DXD_SYSERRLIST_DECL 1
#define DXD_SOCKET_UNIXDOMAIN_OK 1
#define DXD_HAS_GETDTABLESIZE    1
#define DXD_HAS_GETHOSTBYNAME    1
#define DXD_HAS_RLIMIT 1
#define DXD_HW_TMESH_ORIENT_SENSITIVE 1
#define DXD_HW_XSERVER_MOVE_OK 1
#define DXD_HAS_CRYPT  1
#define herror perror
#define RSH "/usr/ucb/rsh"
#define DXD_HAS_UNIX_SYS_INCLUDES 1
#define DXD_HAS_UNISTD_H 1
#define DXD_GAMMA_8BIT  2.0
#define DXD_GAMMA_12BIT	2.0
#define DXD_GAMMA_24BIT 2.0
#define DXD_HAS_VFORK 1
#endif  
#ifdef solaris
typedef signed char     byte;
typedef unsigned char	ubyte;
#include <sys/types.h>
#define DXD_ARCHNAME  "solaris"
#define DXD_LICENSED_VERSION 1
#define DXD_BIGENDIAN 1
#define DXD_STANDARD_IEEE 1
#define DXD_IS_MP 1
#define DXD_EXEC_WAIT_PROCESS 1
#define DXD_PROCESSOR_STATUS 1
#define DXD_HAS_SYSCONF 1
#define DXD_CAN_HAVE_HW_RENDERING 1
#define DXD_POPEN_OK 1
#define DXD_SYSERRLIST_DECL 1
#define DXD_SOCKET_UNIXDOMAIN_OK 1
#define DXD_HAS_GETHOSTBYNAME    1
#define MAXFUPLIM FD_SETSIZE
#define DXD_HAS_RLIMIT 1
#define DXD_HW_TMESH_ORIENT_SENSITIVE 1
#define DXD_HAS_CRYPT  1
#define herror perror
#define RSH "/usr/bin/rsh"
union wait{
   int status;
   };
#define bcopy(s,d,n)	memcpy((void *)(d),(void *)(s),(int)(n))
#define bzero(s,n)	memset((void *)(s),0,(int)(n))
#define bcmp(s1,s2,n)	memcmp((void *)(s1),(void *)(s2),(int)(n))
#ifdef __PURIFY__
# define DXD_USE_MUTEX_LOCKS 0
#else
# define DXD_USE_MUTEX_LOCKS 1
#endif
#define DXD_HAS_UNIX_SYS_INCLUDES 1
#define DXD_HAS_UNISTD_H 1
#define DXD_GAMMA_8BIT  2.0
#define DXD_GAMMA_12BIT	2.0
#define DXD_GAMMA_24BIT 2.0
#define DXD_NO_MP_RUNTIME 1
#define DXD_HAS_VFORK 1
#endif  
#ifdef aviion
typedef unsigned char   uchar;
typedef signed char     byte;
typedef unsigned char	ubyte;
#include <sys/types.h>
#define DXD_ARCHNAME  "aviion"
#define DXD_LICENSED_VERSION 1
#define DXD_BIGENDIAN 1
#define DXD_STANDARD_IEEE 1
#define DXD_POPEN_OK 1
#define DXD_SYSERRLIST_DECL 1
#define DXD_PRINTF_RETURNS_COUNT 1
#define DXD_SOCKET_UNIXDOMAIN_OK 1
#define DXD_HAS_GETDTABLESIZE    1
#define DXD_HAS_GETHOSTBYNAME    1
#define DXD_HAS_RLIMIT 1
#define DXD_HAS_CRYPT  1
#define herror perror
#define RSH "/usr/bin/remsh"
#define DXD_HAS_UNIX_SYS_INCLUDES 1
#define DXD_HAS_UNISTD_H 1
#define DXD_GAMMA_8BIT  2.0
#define DXD_GAMMA_12BIT	2.0
#define DXD_GAMMA_24BIT 2.0
#define DXD_HAS_VFORK 1
#endif  
#if defined(intel) || defined(intelnt)  || defined(DXD_WIN)
#define DXD_CAN_HAVE_HW_RENDERING 1
typedef unsigned char   uchar;
typedef signed char     byte;
typedef unsigned char	ubyte;
typedef unsigned short  ushort;
typedef unsigned int    uint;
#include <sys/types.h>
#define fork() -1
#define DXD_ARCHNAME  "intel"
#define DXD_SYSERRLIST_DECL 1
#define DXD_PRINTF_RETURNS_COUNT 1
#define DXD_SOCKET_WINSOCKETS_OK 1
#define DXD_GAMMA_8BIT  2.0
#define DXD_GAMMA_12BIT	2.0
#define DXD_GAMMA_24BIT 2.0
#endif  
#ifdef intelnt
#define	DXD_WIN	
#define DXD_POPEN_OK 1
#define RSH  "rsh"
#define DXD_OS_NON_UNIX      1
#define DXD_HAS_WINSOCKETS   1
#define MAXHOSTNAMELEN       128
#define MAXPATHLEN           255
#define	EXCEED_SOCKET	1 
#define DXD_SOCKET_WINSOCKETS_OK 1
#define DXD_NON_UNIX_DIR_SEPARATOR 1
#define DXD_NON_UNIX_ENV_SEPARATOR 1
#define	_WINERROR_ 1
#define _DLGSH_INCLUDED_  1  
#include <windows.h>
#include <errno.h>
typedef unsigned char   uchar;
typedef signed char     byte;
typedef unsigned char	ubyte;
typedef unsigned short  ushort;
typedef unsigned int    uint;
typedef unsigned long   ulong;
#define DXD_ARCHNAME  "intelnt"
#define DXD_SYSERRLIST_DECL 1
#define DXD_PRINTF_RETURNS_COUNT 1
#define DXD_SELECTPTR_DEFINED 1
#define SelectPtr  fd_set*
#define DXD_HAS_GETDTABLESIZE	1
#define DXD_STANDARD_IEEE 1
#define DXD_LACKS_UNIX_UID 1
#include <string.h>
#include <stdio.h>
#define BSD_SELECT 1
#include <sys/types.h>
#undef	LONG
#undef	SHORT
#undef  CHAR
#define M_PI       3.1415926535897931160E0  
#define M_SQRT2    1.4142135623730951455E0  
#define herror WSAGetLastError()
#include <io.h>
#include <process.h>
#include <direct.h>
extern  fd_set sockSet;
#define SOCK_ZERO() FD_ZERO(&sockSet)
#define SOCK_SETSOCKET(fd) FD_SET(fd,&sockSet)
#define SOCK_CLRSOCKET(fd) FD_CLR(fd,&sockSet)
#define SOCK_ISSOCKET(fd) FD_ISSET(fd,&sockSet)
int gettablesize(void);
int getopt(int,char**,char*);
int os2_select();
int 	_dxf_nu_pipe(int *fds);
FILE*	_dxf_nu_fopen(const char *filename, const char *mode);
#define fopen(file,mode) _dxf_nu_fopen(file,mode"b")
#define open(path,oflag)  _open(path,oflag|O_BINARY&(~O_CREAT),0)
#define creat(path,mode) _open(path, O_WRONLY | O_CREAT | O_TRUNC | O_BINARY, mode)
#define close(fd) \
	if(SOCK_ISSOCKET(fd))  \
	{	\
		SOCK_CLRSOCKET(fd);	\
		closesocket(fd);	\
	}	\
	else	\
	_close(fd);
#define lseek(fd,offset,whence)	\
	(SOCK_ISSOCKET(fd) ? \
	 errno = EBADF,-1 : \
	 _lseek(fd,offset,whence))
#define read(fd,buff,count) \
	(SOCK_ISSOCKET(fd) ? \
	 _dxf_os2_recv(fd,(char *)buff,count,0) : \
	 _read(fd,buff,count))
#define write(fd,buff,count) \
	(SOCK_ISSOCKET(fd) ? \
	 _dxf_os2_send(fd,(char *)buff,count,0) : \
	 _write(fd,buff,count))
#define wait(status)  cwait(status, status, 0)
#define getpid() _getpid()
#define dup2(old,new)	\
	(SOCK_ISSOCKET(new)  || SOCK_ISSOCKET(old) ? \
	 errno = EBADF,-1 : \
	 _dup2(old,new))
#define pipe(fds)	_dxf_nu_pipe(fds)
#define chdir(path)  _chdir(path)
#define getcwd(buffer,size)  _getcwd(buffer,size)
#define srand48(seed)  srand(seed)
#define lrand48() ((rand() * RAND_MAX) + rand())
#define drand48() ((double)lrand48()/((double)RAND_MAX*(double)RAND_MAX))
#define trunc(value) ((float)((int)(value)))
#define rint(value) ((float)((int)((value) + 0.5)))
#define isatty(fd) _isatty(fd)
#define S_ISDIR(x) ((x) & (S_IFDIR))
#undef  select	
#define select(count,rmask,wmask,emask,timeout)  \
	os2_select(count,rmask,wmask,emask,timeout)
#define fork	DXWinFork
#define herror WSAGetLastError
#define DXD_GAMMA_8BIT  2.0
#define DXD_GAMMA_12BIT	2.0
#define DXD_GAMMA_24BIT 2.0
#define bcopy(s,d,n)	memcpy((void *)(d),(void *)(s),(int)(n))
#define bzero(s,n)		memset((void *)(s),0,(int)(n))
#define bcmp(s1,s2,n)	memcmp((void *)(s1),(void *)(s2),(int)(n))
#ifdef ERROR_INVALID_DATA
#undef ERROR_INVALID_DATA
#endif 
#ifdef scr1
#undef scr1
#endif 
#ifdef scr2
#undef scr2
#endif 
#endif  
#ifdef os2
typedef unsigned char   uchar;
typedef signed char     byte;
typedef unsigned char	ubyte;
typedef unsigned short  ushort;
typedef unsigned int    uint;
typedef unsigned long   ulong;
#define DXD_ARCHNAME  "os2"
#define DXD_OS_NON_UNIX      1
#define DXD_SYSERRLIST_DECL 1
#define DXD_PRINTF_RETURNS_COUNT 1
#define DXD_SELECTPTR_DEFINED 1
#define SelectPtr  fd_set*
#define DXD_HAS_GETDTABLESIZE	1
#define DXD_NEEDS_SYS_SELECT_H 1
#define DXD_HAS_OS2_CP 1
#define DXD_HAS_IBM_OS2_SOCKETS 1
#define DXD_LACKS_UNIX_UID 1
#define DXD_OS2_SYSCALL 1
#define DXD_STANDARD_IEEE 1
#define DXD_LACKS_HDF_FORMAT 1
#define DXD_LACKS_CDF_FORMAT 1
#define DXD_LACKS_NCDF_FORMAT 1
#include <string.h>
#include <stdio.h>
#define BSD_SELECT 1
#include <types.h>
#include <sys/select.h>
#define INCL_DOS
#include <os2.h>
#undef	LONG
#undef	SHORT
#undef  CHAR
#define M_PI       3.1415926535897931160E0  
#define M_SQRT2    1.4142135623730951455E0  
#define herror psock_errno
#include <io.h>
#include <process.h>
#include <direct.h>
extern  fd_set sockSet;
#define SOCK_ZERO() FD_ZERO(&sockSet)
#define SOCK_SETSOCKET(fd) FD_SET(fd,&sockSet)
#define SOCK_CLRSOCKET(fd) FD_CLR(fd,&sockSet)
#define SOCK_ISSOCKET(fd) FD_ISSET(fd,&sockSet)
int gettablesize(void);
int getopt(int,char**,char*);
int os2_select();
int 	_dxf_nu_pipe(int *fds);
FILE*	_dxf_nu_fopen(const char *filename, const char *mode);
#define fopen(file,mode) _dxf_nu_fopen(file,mode"b")
#define open(path,oflag) \
	_open(path,oflag|O_BINARY&(~O_CREAT),0)
#define creat(path,mode) \
	_open(path, O_WRONLY | O_CREAT | O_TRUNC | O_BINARY, mode)
#define close(fd) \
	(SOCK_ISSOCKET(fd) ? \
	 SOCK_CLRSOCKET(fd),soclose(fd) : \
	 _close(fd))
#define lseek(fd,offset,whence)	\
	(SOCK_ISSOCKET(fd) ? \
	 errno = EBADF,-1 : \
	 _lseek(fd,offset,whence))
#define read(fd,buff,count) \
	(SOCK_ISSOCKET(fd) ? \
	 UxRecv(fd,(char *)buff,count,0) : \
	 _read(fd,buff,count))
#define write(fd,buff,count) \
	(SOCK_ISSOCKET(fd) ? \
	 UxSend(fd,(char *)buff,count,0) : \
	 _write(fd,buff,count))
#define wait(status) \
	_wait(status)
#define getpid() \
	_getpid()
#define dup2(old,new)	\
	(SOCK_ISSOCKET(new)  || SOCK_ISSOCKET(old) ? \
	 errno = EBADF,-1 : \
	 _dup2(old,new))
#define pipe(fds)	\
	_dxf_nu_pipe(fds)
#define chdir(path) \
	_chdir(path)
#define getcwd(buffer,size) \
	_getcwd(buffer,size)
#define srand48(seed) \
	srand(seed)
#define lrand48() \
	((rand() * RAND_MAX) + rand())
#define drand48() \
	((double)lrand48()/((double)RAND_MAX*(double)RAND_MAX))
#define trunc(value) \
	((float)((int)(value)))
#define rint(value) \
	((float)((int)((value) + 0.5)))
#define isatty(fd) \
	_isatty(fd)
#define S_ISDIR(x) \
	((x) & (S_IFDIR))
#undef  select	
#define select(count,rmask,wmask,emask,timeout) \
	os2_select(count,rmask,wmask,emask,timeout)
#define fork() (-1)
#define DXD_GAMMA_8BIT  2.0
#define DXD_GAMMA_12BIT	2.0
#define DXD_GAMMA_24BIT 2.0
#endif  
#ifdef alphax
typedef signed char     byte;
typedef unsigned char	ubyte;
#include <sys/types.h>
#define DXD_ARCHNAME  "alphax"
#define DXD_STANDARD_IEEE 1
#define DXD_LICENSED_VERSION 1
#define DXD_POPEN_OK 1
#define DXD_PRINTF_RETURNS_COUNT 1
#define DXD_SOCKET_UNIXDOMAIN_OK 1
#define DXD_HAS_GETDTABLESIZE    1
#define DXD_CAN_HAVE_HW_RENDERING 1
#define DXD_HAS_RLIMIT 1
#define DXD_HW_DC_RIGHT_HANDED 1
#define DXD_EXEC_STATUS_DISPLAY 1
#define DXD_NO_ANSI_ALERT 1
#define DXD_HAS_CRYPT 1
#define RSH  "/usr/bin/rsh"
#define DXD_HAS_UNIX_SYS_INCLUDES 1
#define DXD_HAS_UNISTD_H 1
typedef signed char    int8;
typedef unsigned char  uint8;
typedef short          int16;
typedef unsigned short uint16;
typedef int            int32;
typedef unsigned int   uint32;
typedef long           int64;
typedef unsigned long  uint64;
typedef float          float32;
typedef double         float64;
#define DXD_FIXEDSIZES 1 
#define DXD_GAMMA_8BIT  2.0
#define DXD_GAMMA_12BIT	2.0
#define DXD_GAMMA_24BIT 2.0
#endif   
#define DXD_MAX_BYTE            127
#define DXD_MIN_BYTE           -128
#define DXD_MAX_UBYTE           255
#define DXD_MAX_SHORT         32767
#define DXD_MIN_SHORT        -32768
#define DXD_MAX_USHORT        65535
#define DXD_MAX_INT      2147483647
#define DXD_MIN_INT     -2147483648
#define DXD_MAX_UINT     4294967295
#define DXD_MAX_FLOAT       ((float)3.40282346638528860e+38)
#define DXD_FLOAT_EPSILON   ((float)1.1920928955078125e-7)
#define DXD_MAX_DOUBLE      1.7976931348623157e+308
#define DXD_DOUBLE_EPSILON  2.2204460492503131e-16
#if DXD_STANDARD_IEEE
#define DXD_MIN_FLOAT       ((float)1.40129846432481707e-45)
#define DXD_MIN_DOUBLE      4.94065645841246544e-324
#else   
#define DXD_MIN_FLOAT       ((float)1.1754943508222875e-38)
#define DXD_MIN_DOUBLE      2.2250738585072014e-308
#endif
#ifndef DXD_HW_REPARENT_OFFSET_X
#define DXD_HW_REPARENT_OFFSET_X 0
#endif
#ifndef DXD_HW_REPARENT_OFFSET_Y
#define DXD_HW_REPARENT_OFFSET_Y 0
#endif
#ifndef DXD_HW_XSERVER_MOVE_OK
#define DXD_HW_XSERVER_MOVE_OK 0
#endif
#ifndef DXD_SELECTPTR_DEFINED
typedef void * SelectPtr;
#endif
#ifndef DXD_FIXEDSIZES
/*typedef signed char    int8;*/
typedef unsigned char  uint8;
/*typedef short          int16;*/
typedef unsigned short uint16;
/*typedef int            int32;*/
typedef unsigned int   uint32;
typedef float          float32;
typedef double         float64;
#define DXD_FIXEDSIZES 1 
#endif
#if defined(DXD_ENABLE_SOCKET_POINTERS) && (defined(DXD_HAS_IBM_OS2_SOCKETS) || defined(DXD_HAS_WINSOCKETS))
#ifdef DXD_HAS_WINSOCKETS
#include <winsock.h>
#else
#include <sys/socket.h>
#endif
typedef struct SOCKETS {
    unsigned long	_count;		
    unsigned long	isasocket;
    char		buffer[BUFSIZ];
    char		*nextchar;
    unsigned long	fileno;
} DX_SOCKET;
	
typedef union SFILES {
	FILE	file;
	DX_SOCKET	socket;
} SFILE;
#define SOCK_ISSOCKET_SFILE(sfile) ((sfile)->socket.isasocket == SOCKET_MAGIC_NUMBER) 
#define SOCKET_MAGIC_NUMBER 0xFA1CEFD
	
#define fileno(sfile) \
	(SOCK_ISSOCKET_SFILE(sfile) ? \
	 (sfile)->socket.fileno : \
	 _dxf_nu_fileno(&(sfile)->file))
#define fdopen(fd, mode) \
	(SOCK_ISSOCKET(fd) ? \
	 _dxf_sock_fdopen(fd,mode) : \
	 _fdopen(fd,mode))
#define fclose(sfile) \
	_dxf_nu_fclose(sfile)
#define GETC(sfile) \
	(SOCK_ISSOCKET_SFILE(sfile) ? \
	 _dxf_sock_getc(&(sfile)->socket) : \
	 getc(&(sfile)->file))
#ifdef	DXD_HAS_WINSOCKETS
#define CHAR_READY(sfile) \
	(SOCK_ISSOCKET_SFILE(sfile) ? \
	 ((sfile)->socket._count > 0) : \
	 ((sfile)->file._cnt > 0))
#else
#define CHAR_READY(sfile) \
	(SOCK_ISSOCKET_SFILE(sfile) ? \
	 ((sfile)->socket._count > 0) : \
	 ((sfile)->file._count > 0))
#endif
int 	_dxf_nu_fileno(FILE* file);
int 	_dxf_nu_fclose(SFILE* file);
DX_SOCKET*	_dxf_sock_fdopen(int fd, char* mode);
int 	_dxf_sock_getc(SOCKET *file);
#else 
#define SFILE FILE
#define CHAR_READY(fp) ((fp)->_cnt > 0)
#define GETC(file) getc(file)
#endif
#if !defined(DXD_HAS_IBM_OS2_SOCKETS) && !defined(DXD_HAS_WINSOCKETS)
#define IOCTL ioctl
#endif
#if DXD_HAS_IBM_OS2_SOCKETS
#define IOCTL(fd,cmd,buf) \
	(SOCK_ISSOCKET(fd) ? \
	 ioctl(fd,cmd,(char *)buf, \
              (cmd == FIONREAD || cmd == FIONBIO) ? sizeof (int) : 0) : \
	 -1)
#endif
#ifdef	DXD_HAS_WINSOCKETS
#define IOCTL(fd,cmd,buf) \
	(SOCK_ISSOCKET(fd) ? \
	 ioctlsocket(fd,cmd,(char *)buf, \
              (cmd == FIONREAD || cmd == FIONBIO) ? sizeof (int) : 0) : \
	 -1)
#endif
#endif  
