#include <IMF.h>
#include <IMFExpansion.h>
#include <IMFFlow.h>
#include <IMFFixedPt.h>
#include <math.h>
#include <IMFLorenz.h>
#include <IMFSphereOnExpansion.h>
#include <IMFExpansionSpace.h>
#include <IMFIntegrateFat.h>
#include <IMFInterpolation.h>
#include <stdio.h>
#ifdef DMALLOC
#include <dmalloc.h>
#endif

int main(int argc, char *argv[])
 {
  IMFFlow L;
  MFAtlas A;
  MFNRegion Omega;
  MFNVector u0;
  MFNVector ll;
  MFNVector ur;
  char name[1024];
  int i;

  double eps=.5;
  double dt=.01;
  double tmax=050.;
  int maxInterp=50000;
  int maxCharts=900000;

  L=IMFCreateFlow(3,lorenz,dlorenz,ddlorenz,dddlorenz);

  ll=MFCreateNVector(3);
  MFNVSetC(ll,0,-70.);
  MFNVSetC(ll,1,-70.);
  MFNVSetC(ll,2,-30.);

  ur=MFCreateNVector(3);
  MFNVSetC(ur,0,70.);
  MFNVSetC(ur,1,70.);
  MFNVSetC(ur,2,100.);

  Omega=MFNRegionCreateHyperCubeByCorners(3,ll,ur);
  MFFreeNVector(ll);
  MFFreeNVector(ur);

  u0=MFCreateNVector(3);
  MFNVSetC(u0,0,0.);
  MFNVSetC(u0,1,0.);
  MFNVSetC(u0,2,0.);

  i=tmax;
  sprintf(name,"LorenzU0%3.3d",i);
  A=IMFComputeStableInvariantManifold(L,name,u0,Omega,eps,dt,tmax,maxInterp,maxCharts,2.,0);

  MFFreeAtlas(A);
  MFFreeNVector(u0);
  MFFreeNRegion(Omega);
  IMFFreeFlow(L);

  return 0;
 }
