/* 
    %W%
    %D% %T%
   

    (c) COPYRIGHT INTERNATIONAL BUSINESS MACHINES
    CORPORATION 12/1/2001.  ALL RIGHTS RESERVED.

    Please refer to the LICENSE file in the top directory

*/
/*      author: Mike Henderson mhender@watson.ibm.com */

#include <MFAtlas.h>
#include <MFAtlasFriends.h>
#include <MFNRegion.h>
#include <MFNVector.h>
#include <math.h>
#include <sh.h>

int MFComputePointsOn3dEdge(double r,double **x,double xa,double ya,double za,double xb,double yb,double zb)
 {
  double R,t;
  int i,n;
  int verbose=0;

  if(verbose){printf("MFComputePointsOn3dEdge(%lf,%8.8x,%lf,%lf,%lf,%lf,%lf,%lf)\n",r,*x,xa,ya,za,xb,yb,zb);fflush(stdout);}

  R=sqrt(pow(xa-xb,2)+pow(ya-yb,2)+pow(za-zb,2));
  n=floor(R/r)+1;
  if(verbose){printf("  allocating space for %d points\n",n);fflush(stdout);}
  *x=(double*)realloc((void*)(*x),3*n*sizeof(double));
  if(verbose) 
   {
    printf("  space at %8.8x\n",*x);fflush(stdout);
    printf("  Distance between points is %lf, r=%lf\n",R/n,r);fflush(stdout);
   }
  for(i=0;i<n;i++)
   {
    t=(i+1)*1./(n+1);
    (*x)[3*i  ]=xa+t*(xb-xa);
    (*x)[3*i+1]=ya+t*(yb-ya);
    (*x)[3*i+2]=za+t*(zb-za);
   }

  return n;
 }
