/* 
    @(#)TestReduce.c	1.2
    02/04/19 16:36:24
   
    PROGRAM NAME:  Manifold

    (c) COPYRIGHT INTERNATIONAL BUSINESS MACHINES
    CORPORATION 12/1/2001.  ALL RIGHTS RESERVED.

    Please refer to the LICENSE file in the top directory

*/
/*      author: Mike Henderson mhender@watson.ibm.com */

#include <MFAtlas.h>
#include <MFNRegion.h>
#include <MFNVector.h>
#include <MFPrint.h>
#include <MFDraw.h>
#include <MFEnumPolytope.h>
#include <MFEnumDualPolytope.h>
#include <math.h>

#ifdef DBMALLOC
void   malloc_snapshot( void );
void   malloc_leaks( char *);
#endif

int main(int argc, char *argv[])
 {
  MFImplicitMF M;
  MFNRegion Omega;
  MFAtlas S;
  MFNVector u0;
  MFNVector u;
  double Rmax=.4;
  double epsilon=.1;
  int kkk;
  float xmin,xmax,dist,alpha,beta;
  int gray;
  MFEnumDualPolytope P;
  MFEnumPolytope Q;
  int chart;
  double delta;
  int Draw,DrawOnce,DrawPoly,DrawPolyOnce;
  FILE *fid;

  double R=1.;
  Draw=0;
  DrawOnce=0;
  DrawPoly=0;
  DrawPolyOnce=0;

#ifdef DBMALLOC
  malloc_snapshot();
#endif

  Rmax=sqrt(2*R*epsilon);

  printf("%s\n",argv[0]);

  M=MFIMFCreatePlane();
  Omega=MFNRegionCreateRectangle(-.9,-.9,.9,.9);

  MFDrawInitializeCube(0.,90.,-.3,.3,-.3,.3,-1.,1.);

  kkk=0;
  S=MFCreateAtlas(M);

  u0=MFCreateNVector(2);
  MFNVSetC(u0,0, 0.);
  MFNVSetC(u0,1, 0.);
  printf("%d) Add initial point to Atlas ",kkk);MFPrintNVector(stdout,u0);printf("\n");fflush(stdout);
  MFAtlasAddChart(S,u0);
  MFFreeNVector(u0);
  kkk++;

  u0=MFCreateNVector(2);
  MFNVSetC(u0,0, .1);
  MFNVSetC(u0,1, 0.);
  printf("%d) Add initial point to Atlas ",kkk);MFPrintNVector(stdout,u0);printf("\n");fflush(stdout);
  MFAtlasAddChart(S,u0);
  MFFreeNVector(u0);
  kkk++;

  u0=MFCreateNVector(2);
  MFNVSetC(u0,0, .0707);
  MFNVSetC(u0,1, .0707);
  printf("%d) Add initial point to Atlas ",kkk);MFPrintNVector(stdout,u0);printf("\n");fflush(stdout);
  MFAtlasAddChart(S,u0);
  MFFreeNVector(u0);
  kkk++;

  u0=MFCreateNVector(2);
  MFNVSetC(u0,0, 0.);
  MFNVSetC(u0,1, .1);
  printf("%d) Add initial point to Atlas ",kkk);MFPrintNVector(stdout,u0);printf("\n");fflush(stdout);
  MFAtlasAddChart(S,u0);
  MFFreeNVector(u0);
  kkk++;

  u0=MFCreateNVector(2);
  MFNVSetC(u0,0,-.0707);
  MFNVSetC(u0,1, .0707);
  printf("%d) Add initial point to Atlas ",kkk);MFPrintNVector(stdout,u0);printf("\n");fflush(stdout);
  MFAtlasAddChart(S,u0);
  MFFreeNVector(u0);
  kkk++;

  u0=MFCreateNVector(2);
  MFNVSetC(u0,0,-.1);
  MFNVSetC(u0,1, 0.);
  printf("%d) Add initial point to Atlas ",kkk);MFPrintNVector(stdout,u0);printf("\n");fflush(stdout);
  MFAtlasAddChart(S,u0);
  MFFreeNVector(u0);
  kkk++;

  u0=MFCreateNVector(2);
  MFNVSetC(u0,0,-.0707);
  MFNVSetC(u0,1,-.0707);
  printf("%d) Add initial point to Atlas ",kkk);MFPrintNVector(stdout,u0);printf("\n");fflush(stdout);
  MFAtlasAddChart(S,u0);
  MFFreeNVector(u0);
  kkk++;

  u0=MFCreateNVector(2);
  MFNVSetC(u0,0, 0.);
  MFNVSetC(u0,1,-.1);
  printf("%d) Add initial point to Atlas ",kkk);MFPrintNVector(stdout,u0);printf("\n");fflush(stdout);
  MFAtlasAddChart(S,u0);
  MFFreeNVector(u0);
  kkk++;

  u0=MFCreateNVector(2);
  MFNVSetC(u0,0, .0707);
  MFNVSetC(u0,1,-.0707);
  printf("%d) Add initial point to Atlas ",kkk);MFPrintNVector(stdout,u0);printf("\n");fflush(stdout);
  MFAtlasAddChart(S,u0);
  MFFreeNVector(u0);
  kkk++;

  printf("Done adding initial points\n");fflush(stdout);
  MFDrawAtlas(S);MFDrawDisplay();

  printf("Reducing the size of chart 0\n");fflush(stdout);
  MFAtlasReduceChartRadius(S,0,.07);
  printf("Done reducing the size of chart 0\n");fflush(stdout);

  MFDrawClear();MFDrawAtlasOnce(S);MFDrawDisplay();

  MFFreeAtlas(S);
  MFFreeImplicitMF(M);
  MFFreeNRegion(Omega);

  MFDrawClose();

  return(0);
 }
